'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.authMiddleware = exports.LoginActions = undefined;

var _index = require('./index');

var _axios = require('axios');

var baseUrl = '/api/auth/';

// TODO(vjpr): Get rid of Axios dependency.
var LoginActions = exports.LoginActions = (0, _index.createActions)({
  login: function login(credentials) {
    return (0, _axios.post)(baseUrl + 'login', credentials);
  },
  unauthorizedRequest: function unauthorizedRequest(error) {
    // We set this to `lastError`, otherwise it will cause an infinite loop because
    // we check for errors in the `authMiddleware`.
    return { lastError: error };
  }
});

var authMiddleware = exports.authMiddleware = function authMiddleware(store) {
  return function (next) {
    return function (action) {
      if (action.error && action.error.status === 401) {
        return store.dispatch(LoginActions.unauthorizedRequest(action.error));
      }
      next(action);
    };
  };
};
//# sourceMappingURL=auth.js.map
