'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * Logs all actions and states after they are dispatched.
 */
var loggingMiddleware = exports.loggingMiddleware = function loggingMiddleware(logger) {
  return function (store) {
    return function (next) {
      return function (action) {
        logger.group(action.type);
        logger.info('dispatching', action);
        var result = next(action);
        logger.log('next state', store.getState());
        logger.groupEnd(action.type);
        return result;
      };
    };
  };
};

// Old one.
//export function loggingMiddleware(log) {
//  return ({/* dispatch, getState */}) =>
//    (next) => (action) => {
//      log(action)
//      next(action)
//    }
//}
//# sourceMappingURL=logging.js.map
