import {createActions} from './index'

// TODO(vjpr): Get rid of Axios dependency.
import {post as postToServer, get as getFromServer} from 'axios'

const baseUrl = '/api/auth/'

export const LoginActions = createActions({

  login(credentials) {
    return postToServer(baseUrl + 'login', credentials)
  },

  unauthorizedRequest(error) {
    // We set this to `lastError`, otherwise it will cause an infinite loop because
    // we check for errors in the `authMiddleware`.
    return {lastError: error}
  }

})


export const authMiddleware = store => next => action => {
  if (action.error && action.error.status === 401) {
    return store.dispatch(LoginActions.unauthorizedRequest(action.error))
  }
  next(action)
}
