/**
 * Logs all actions and states after they are dispatched.
 */
export const loggingMiddleware = logger => store => next => action => {
  logger.group(action.type)
  logger.info('dispatching', action)
  let result = next(action)
  logger.log('next state', store.getState())
  logger.groupEnd(action.type)
  return result
}

// Old one.
//export function loggingMiddleware(log) {
//  return ({/* dispatch, getState */}) =>
//    (next) => (action) => {
//      log(action)
//      next(action)
//    }
//}
